//+------------------------------------------------------------------+
//|                                                   HeikenAshi.mqh |
//|                                                        extern.fx |
//|                                              extern.fx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "extern.fx"
#property link      "extern.fx@gmail.com"
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2010
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import
//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex5"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+
#define BARS_COUNT 32
class HeikenAshi
{
public:
   HeikenAshi();
   ~HeikenAshi();
   bool Create( string _symbol, ENUM_TIMEFRAMES _timeframe );
   double GetOpen( int shift );
   double GetHigh( int shift );
   double GetLow( int shift );
   double GetClose( int shift );
   string GetSymbol();
   ENUM_TIMEFRAMES GetTimeframe();
   string GetTimeframeName();
   double GetBodyLen( int shift );
protected:
   int handle;
   string symbol;
   ENUM_TIMEFRAMES timeframe;
   double open[BARS_COUNT];
   double high[BARS_COUNT];
   double low[BARS_COUNT];
   double close[BARS_COUNT];
};

HeikenAshi::HeikenAshi(void)
{
   handle = 0;
   symbol = "EURUSD";
   timeframe = PERIOD_H1;
   ArraySetAsSeries( open, true );
   ArraySetAsSeries( high, true );
   ArraySetAsSeries( low, true );
   ArraySetAsSeries( close, true );
}

HeikenAshi::~HeikenAshi(void)
{
   IndicatorRelease( handle );
}

bool HeikenAshi::Create(string _symbol,ENUM_TIMEFRAMES _timeframe)
{
   symbol = _symbol;
   timeframe = _timeframe;
   handle = iCustom( symbol, timeframe, "Examples\\Heiken_Ashi" );
   if( handle < 0 )
   {
      Print( "   Heiken Ashi #: ", GetLastError() );
      return( false );
   }
   else Print( "Heiken Ashi Handle: ", handle );
   
   if( CopyBuffer( handle, 0, 0, BARS_COUNT, open ) < 0 )
   {
      Print( "   open[] #:", GetLastError() );
      return( false );
   }
   
   if( CopyBuffer( handle, 1, 0, BARS_COUNT, high ) < 0)
   {
      Print( "   open[] #:", GetLastError() );
      return( false );
   }
   
   if( CopyBuffer( handle, 2, 0, BARS_COUNT, low ) < 0 )
   {
      Print( "   open[] #:", GetLastError() );
      return( false );
   }
   
   if( CopyBuffer( handle, 3, 0, BARS_COUNT, close ) < 0 )
   {
      Print( "   open[] #:", GetLastError() );
      return( false );
   }
   return( true );
}

double HeikenAshi::GetOpen(int shift)
{
   return( open[shift] );
}

double HeikenAshi::GetHigh(int shift)
{
   return( high[shift] );
}

double HeikenAshi::GetLow(int shift)
{
   return( low[shift] );
}

double HeikenAshi::GetClose(int shift)
{
   return( close[shift] );
}

string HeikenAshi::GetSymbol(void)
{
   return( symbol );
}

ENUM_TIMEFRAMES HeikenAshi::GetTimeframe(void)
{
   return( timeframe );
}

string HeikenAshi::GetTimeframeName(void)
{
   switch( timeframe )
   {
      case PERIOD_M1:  return("M1");
      case PERIOD_M2:  return("M2");
      case PERIOD_M3:  return("M3");
      case PERIOD_M4:  return("M4");
      case PERIOD_M5:  return("M5");
      case PERIOD_M6:  return("M6");
      case PERIOD_M10: return("M10");
      case PERIOD_M12: return("M12");
      case PERIOD_M15: return("M15");
      case PERIOD_M20: return("M20");
      case PERIOD_M30: return("M30");
      case PERIOD_H1:  return("H1");
      case PERIOD_H2:  return("H2");
      case PERIOD_H3:  return("H3");
      case PERIOD_H4:  return("H4");
      case PERIOD_H6:  return("H6");
      case PERIOD_H8:  return("H8");
      case PERIOD_H12: return("H12");
      case PERIOD_D1:  return("Daily");
      case PERIOD_W1:  return("Weekly");
      case PERIOD_MN1: return("Monthly");
   }
//---
   return("UNKNOWN_PERIOD");
}

double HeikenAshi::GetBodyLen(int shift)
{
   return( close[shift] - open[shift] );
}